program Equation_Solving;
uses crt;

const
   Eps=0.01;
   RootsPlaces:array [1..3,1..2] of Real=((-4,-3),(-2,-1),(3,4));

type Methods=(Half,Tang,Sec);

var i,j:byte;
    found:boolean;
    used:array[methods]of boolean;

function MyFunction(x:real):real;
begin
   MyFunction:=-13.392-11.358*x+1.176*sqr(x)+x*sqr(x);
end;

function MyFunctionDerived1st(x:real):real;    { f'(x) }
begin
   MyFunctionDerived1st:=-11.358+1.176*2*x+3*sqr(x);
end;

function MyFunctionDerived2nd(x:real):real;    { f''(x) }
begin
   MyFunctionDerived2nd:=1.176*2+6*x;
end;

procedure Hat(rn:byte);
begin
   ClrScr;
   WriteLn('७ N',i,' 饬  ࢠ (',rootsplaces[i,1]:4:2,' ; ',rootsplaces[i,2]:4:2,').');
end;

{  ᨬ ᥢ䨪:
179 -   180 - 
 191 -   192 - 
193 -   194 - 
 195 -   196 - 
197 -   217 - 
 218 -      }

procedure HalfDivision(rn:byte);
var
   a,b,x,fa,fx,fb:real;  { a,b,x,f(A),f(x),f(B),length=(B-A) }
   n:byte; {iteration number}
begin
   Hat(rn);
   WriteLn('⮤  .');
   WriteLn('Ŀ');
   WriteLn(' N  A    x    B   f(A)  f(x)  f(B)  B-A ');
   WriteLn('Ĵ');
   n:=0;
   a:=rootsplaces[rn,1];
   b:=rootsplaces[rn,2];
   repeat
      x:=(a+b)/2;
      fa:=MyFunction(a);
      fx:=MyFunction(x);
      fb:=MyFunction(b);
      if fa*fx<0 then b:=x else a:=x;
      inc(n);
      WriteLn('',n:2,'',a:5:2,'',x:5:2,'',b:5:2,'',fa:6:2,'',fx:6:2,'',fb:6:2,'',(b-a):5:2,'');
   until abs(b-a) <= 2*eps;
   WriteLn('');
   WriteLn('  ⮤   祭.');
   WriteLn('⥫ १: x=',x:4:2,' ; f(x)=',fx:4:2);
   ReadLn;
end;

procedure Tangents(x:real);
var
   fx,fxd1,h:real; { f(x),f'(x),蠣 }
   n:byte; {iteration number}
begin
   WriteLn('⮤ ⥫.');
   WriteLn('Ŀ');
   WriteLn(' N  x   f(x)  f''(x)  H  ');
   WriteLn('Ĵ');
   n:=0;
   repeat
      fx:=MyFunction(x);
      fxd1:=MyFunctionDerived1st(x);
      h:=-fx/fxd1;
      x:=x+h;
      inc(n);
      WriteLn('',n:2,'',x:5:2,'',fx:6:2,'',fxd1:6:2,'',h:5:2,'');
   until abs(h)<=eps;
   WriteLn('');
   WriteLn('  ⮤ ⥫ 祭.');
   WriteLn('⥫ १: x=',x:4:2,' ; f(x)=',fx:4:2);
   ReadLn;
end;

procedure Secants(a,b:real; var x0,x1:real; var s:boolean);
label 13;
var
   x2,fx0,fx1,fx2:real; { x2,f(x0),f(x1),f(x2) }
   n:byte;   {iteration number}
begin
   WriteLn('⮤ ᥪ.');
   WriteLn('Ŀ');
   WriteLn(' N  x0   x1   x2  f(x0) f(x1) f(x2)x1-x0');
   WriteLn('Ĵ');
   n:=0;
   fx0:=MyFunction(x0);
   fx1:=MyFunction(x1);
   while abs(x0-x1)>eps do
      begin
         inc(n);
         x2:=(x0*fx1-x1*fx0)/(fx1-fx0);
         fx2:=MyFunction(x2);
         WriteLn('',n:2,'',x0:5:2,'',x1:5:2,'',x2:5:2,'',fx0:6:2,'',fx1:6:2,'',fx2:6:2,'',(x1-x0):5:2,'');
         if (a<=x2) and (x2<=b) then
            begin
               x0:=x1;
               x1:=x2;
               fx0:=fx1;
               fx1:=fx2;
               s:=true;
            end
           else
            begin
               s:=false;
               goto 13;
            end;
      end;
   WriteLn('');
   WriteLn('  ⮤ ᥪ 祭.');
   WriteLn('⥫ १: x2=',x2:5:2,'; f(x2)=',fx2:5:2);
   ReadLn;
   13:
end;

function TangentsProbability(x0:real):boolean;
begin
   if MyFunction(x0)*MyFunctionDerived2nd(x0)>0 then TangentsProbability:=true
    else TangentsProbability:=false;
end;

procedure UseSecants(rn:byte);
var a,b,x0c,x1c,l:real;      { a,b,x0 current, x1 curent, length }
    finish:boolean;
begin
   a:=rootsplaces[rn,1];
   b:=rootsplaces[rn,2];
   l:=b-a;
   repeat
      Hat(rn);
      x0c:=random*l+a;
      x1c:=random*l+a;
      Secants(a,b,x0c,x1c,finish);
   until finish=true;
end;


begin
   randomize;
   used[half]:=false;
   used[tang]:=false;
   used[sec]:=false;
   for i:=1 to 3 do
      begin
         found:=false;
         if used[tang]=false then
            for j:= 1 to 2 do
               if (TangentsProbability(rootsplaces[i,j])=true) and (found=false) then
                  begin
                     Hat(i);
                     Tangents(rootsplaces[i,j]);
                     used[tang]:=true;
                     found:=true;
                  end;
         if found=false then
            if used[sec]=false then
               begin
                  UseSecants(i);
                  used[sec]:=true;
               end
              else
               begin
                  HalfDivision(i);
                  used[half]:=true;
               end;
      end;
end.