{$M 65520,1024,2048}
program Math_Model_Building_With_Normated_Variables;
uses crt,matrix,matrixex,service,inout;

var x,xn,fx,a:TNvector; {x, x normated, f(x),a}
    xmax,xmin,xm,dx:real; {x maximum, x minimum, x mean, dx}
    i:byte;   {i}
    N,nrep,pp:integer;  {number of dimensions, number of repeated dimensions, polynom's power}
    k_ob,S2res:real;      {k, S2residual}
    p,S2rep:real;  {probability,dispersion of repeatability}
    Fcount,Ftab:real;     {Fisher criterium counting/tabled}


function Polynom(Coeffs:TNvector;arg:real):real;
var work:real;
    j:byte;
begin
   work:=Coeffs[1];
   for j:=2 to (pp+1) do
      work:=work+Coeffs[j]*powerRI(arg,j-1);
   Polynom:=work;
end;

procedure MNK(xi:TNvector;var ai:TNvector;var S2res:real;var k_ob:real);
var
   F,FT,Nm,Nm1:TNmatrix;    {F,FT,FT*F=N,Nm^-1}
   b:TNvector;         {FT*f(x)=b}
   er,j,k:byte;       {error,j,k}
begin
   for j:=1 to N do
      begin
         F[j,1]:=1;
         for k:=2 to (pp+1) do
            F[j,k]:=powerRI(xi[j],k-1);
      end;
   TransposeMatrix(n,pp+1,F,FT);
   MultiplicMatrixs(pp+1,n,pp+1,FT,F,Nm);
   MultiplicMatVec(pp+1,n,FT,fx,b);
   Partial_Pivoting(pp+1,Nm,b,ai,er);
   Inverse(pp+1,Nm,Nm1,er);
   k_ob:=NormaOfMatrix(pp+1,pp+1,Nm)*NormaOfMatrix(pp+1,pp+1,Nm1);
   S2res:=0;
   for j:=1 to n do
      S2res:=S2res+sqr(fx[j]-Polynom(ai,xn[j]));
   S2res:=S2res/(N-pp-1);
end;

procedure WriteModel(aa:TNvector;space,dec:shortint);
var sign:char;
    j:byte;
begin
   Write('y=',aa[1]:space:dec);
   for j:=2 to (pp+1) do
      begin
         if aa[j]<0 then sign:='-' else sign:='+';
         if j=2 then Write(sign,abs(aa[j]):space:dec,'*xn')
           else Write(sign,abs(aa[j]):space:dec,'*xn^',j-1);
      end;
   WriteLn('  ,');
   WriteLn(' xn = (x - ',xm:5:2,' ) / ', dx:5:2);
   WriteLn('      i    i  ');
end;


begin
   ClrScr;
   ReadIntXY(1,1,' ᫮ ७ 㭪樨 ⪫: ',N);
   WriteLn(' ᯥਬ⠫ : ');
   WriteLn('N');
   GotoXY(1,4);
   for i:=1 to N do
      WriteLn(i);
   ReadArr(10,3,'x',N,x);
   ReadArr(30,3,'f(x)',N,fx);
   ReadRealXY(1,22,' ⥫ ⭮: ',p);
   ReadIntXY(1,23,' ᫮  ७: ',nrep);
   ReadRealXY(1,24,' ᯥ ந: ',S2rep);
   ReadIntXY(1,25,' ⥯ ௮饣   ନ஢ ६: ',pp);
   ClrScr;
   xmax:=Max(N,x);
   xmin:=Min(N,x);
   xm:=(xmax+xmin)/2;
   dx:=(xmax-xmin)/2;
   for i:= 1 to n do
      xn[i]:=(x[i]-xm)/dx;
   MNK(xn,a,S2res,k_ob);
   WriteLn(' ',pp,'- ⥯  ନ஢ ६ :');
   WriteModel(a,6,4);
   WriteLn('᫮ ᫮  FT*F =',k_ob:3:0);
   WriteLn('筠 ᯥ =',S2res:7:4);
   WriteLn;
   WriteLn('஢ઠ  ⭮:');
   if S2res > S2rep then
      begin
         Fcount:=S2res/S2rep;
         WriteLn(' ⠡筮 祭    p=',p:4:2);
         Write('f1=',N-pp-2,';  f2=',nrep-1,'  :    ');
         ReadLn(Ftab);
      end
     else
      begin
         Fcount:=S2rep/S2res;
         WriteLn(' ⠡筮 祭    p=',p:4:2);
         Write('f1=',Nrep-1,';  f2=',N-pp-2,'  :    ');
         ReadLn(Ftab);
      end;
   if Fcount<Ftab then
      begin
         WriteLn('  ⥫쭮 ⭮ 0.9  ⭮');
         WriteLn('뢠 ᯥਬ⠫ .');
      end
     else
      begin
         WriteLn('  ⥫쭮 ⭮ 0.9  ⭮');
         WriteLn('뢠 ᯥਬ⠫ .');
      end;
   ReadLn;
end.