{$M 65520,1024,2048}
program Math_Model_Building_With_Ordinary_Variables;
uses crt,matrix,matrixex,service,inout;

type BoolArr=array[0..10] of Boolean;

var x,fx,a1,a2,t:TNvector; {x, f(x),a1,a2,t}
    i,l,noc,naus:byte;   {i,l, number of coefficients, number of a unsignificant}
    N,nrep,pp:integer;  {number of dimensions, number of repeated dimensions, polynom's power}
    k_ob1,k_ob2,S2res1,S2res2:real;      {k1, k2, S2residual1, S2residual2}
    p,S2rep:real;  {probability,dispersion of repeatability}
    Fcount,Ftab:real;     {Fisher criterium counting/tabled}
    PowerExists1,PowerExists2:BoolArr;


function MinimalElem(vec:TNvector;dim:byte):byte;
var j,me:byte;
begin
   me:=1;
   for j:=2 to dim do
      if vec[j]<vec[me] then me:=j;
   MinimalElem:=me;
end;

function Polynom(Coeffs:TNvector;arg:real;PowerExists:BoolArr):real;
var work:real;
    j,l:byte;
begin
   l:=0;
   work:=0;
   for j:=0 to pp do
      if PowerExists[j] then
         begin
            inc(l);
            if j=0 then work:=Coeffs[1]
              else work:=work+Coeffs[l]*powerRI(arg,j);
         end;
   Polynom:=work;
end;


procedure MNK(xi:TNvector;PowerExists:BoolArr;var ai:TNvector;var S2res:real;var k_ob:real);
var
   F,FT,Nm,Nm1:TNmatrix;    {F,FT,FT*F=N,Nm^-1}
   b:TNvector;         {FT*f(x)=b}
   upx:array[0..10] of byte;      {using powers of x}
   er,j,k,nupx:byte;       {error,j,k,number of using powers of x}
begin
   nupx:=0;
   for j:=0 to pp do
      if PowerExists[j] then
         begin
            upx[nupx]:=j;
            inc(nupx);
         end;

   for j:=1 to N do
      if upx[0]=0 then
         begin
            F[j,1]:=1;
            for k:=2 to nupx do
               F[j,k]:=powerRI(xi[j],upx[k-1]);
         end
        else
         for k:=1 to nupx do
            F[j,k]:=powerRI(xi[j],upx[k-1]);
   TransposeMatrix(n,nupx,F,FT);
   MultiplicMatrixs(nupx,n,nupx,FT,F,Nm);
   MultiplicMatVec(nupx,n,FT,fx,b);
   Partial_Pivoting(nupx,Nm,b,ai,er);

   Inverse(nupx,Nm,Nm1,er);
   k_ob:=NormaOfMatrix(nupx,nupx,Nm)*NormaOfMatrix(nupx,nupx,Nm1);

   S2res:=0;
   for j:=1 to n do
      S2res:=S2res+sqr(fx[j]-Polynom(ai,x[j],PowerExists));
   S2res:=S2res/(N-nupx);

   for j:=1 to nupx do
      t[j]:=abs(ai[j])/sqrt(Nm1[j,j]*S2rep);
end;


procedure WriteModel(aa:TNvector;PowerExists:BoolArr;space,dec:shortint);
var sign:char;
    j:byte;
begin
   Write('y=');
   if PowerExists[0] then Write(aa[1]:space:dec);
   for j:=2 to pp+1 do
      if PowerExists[j-1] then
         begin
            if aa[j]<0 then sign:='-' else sign:='+';
            if j=2 then Write(sign,abs(aa[j]):space:dec,'*x')
              else Write(sign,abs(aa[j]):space:dec,'*x^',j-1);
         end;
   WriteLn;
end;


begin
   ClrScr;
   ReadIntXY(1,1,' ᫮ ७ 㭪樨 ⪫: ',N);
   WriteLn(' ᯥਬ⠫ : ');
   WriteLn('N');
   GotoXY(1,4);
   for i:=1 to N do
      WriteLn(i);
   ReadArr(10,3,'x',N,x);
   ReadArr(30,3,'f(x)',N,fx);
   ReadRealXY(1,22,' ⥫ ⭮: ',p);
   ReadIntXY(1,23,' ᫮  ७: ',nrep);
   ReadRealXY(1,24,' ᯥ ந: ',S2rep);
   ReadIntXY(1,25,' ⥯ ௮饣 : ',pp);
   ClrScr;
   noc:=pp+1;
   for l:=0 to pp do
       PowerExists2[l]:=true;
   MNK(x,PowerExists2,a2,S2res2,k_ob2);
   WriteLn(' ',pp,'- ⥯ ');
   WriteModel(a2,PowerExists2,6,4);
   WriteLn('᫮ ᫮  FT*F =',k_ob2:2:0);
   WriteLn('筠 ᯥ =',S2res2:7:4);
   WriteLn;
   WriteLn('롮 ⥫쭮  ⥬᪮ :');
      repeat
         PowerExists1:=PowerExists2;
         a1:=a2;
         S2res1:=S2res2;
         k_ob1:=k_ob2;
         naus:=MinimalElem(t,noc);
         i:=0;
         l:=0;
         while i<>naus do
            begin
               if PowerExists2[l] then inc(i);
               inc(l);
            end;
         PowerExists2[l-1]:=False;
         dec(noc);
         MNK(x,PowerExists2,a2,S2res2,k_ob2);
         WriteModel(a2,PowerExists2,6,4);
         WriteLn('᫮ ᫮  FT*F =',k_ob2:2:0);
         WriteLn('筠 ᯥ = ',S2res2:7:4);
         WriteLn;
      until (S2res2 >= S2res1) or (noc=1);
   if (noc=1) and (S2res2 < S2res1) then
      begin
         a1:=a2;
         PowerExists1:=PowerExists2;
         k_ob1:=k_ob2;
         S2res1:=S2res2;
      end;
   ReadLn;
   ClrScr;
   WriteLn('⥫  ⥬᪮ :');
   WriteModel(a1,PowerExists1,6,4);
   WriteLn('᫮ ᫮  FT*F =',k_ob1:2:0);
   WriteLn('筠 ᯥ =',S2res1:7:4);
   Writeln;
   WriteLn('஢ઠ  ⭮:');
   if S2res1 > S2rep then
      begin
         Fcount:=S2res1/S2rep;
         WriteLn(' ⠡筮 祭    p=',p:4:2);
         Write('f1=',N-noc-1,';  f2=',nrep-1,'  :    ');
         ReadLn(Ftab);
      end
     else
      begin
         Fcount:=S2rep/S2res1;
         WriteLn(' ⠡筮 祭    p=',p:4:2);
         Write('f1=',Nrep-1,';  f2=',N-noc-1,'  :    ');
         ReadLn(Ftab);
      end;
   if Fcount<Ftab then
      begin
         WriteLn('  ⥫쭮 ⭮ 0.9  ⭮');
         WriteLn('뢠 ᯥਬ⠫ .');
      end
     else
      begin
         WriteLn('  ⥫쭮 ⭮ 0.9  ⭮');
         WriteLn('뢠 ᯥਬ⠫ .');
      end;
   ReadLn;
end.